$(function() {
	readSettingFromSearch();
	
	initTable_yokutsukau();
	initTable();
	initSelect();
	
	initWindowSize();
	
	isReadyTable = true;
	
	// ウインドウをずらす座標
	var pos = findPos( document.getElementById("selectTable") );
	var x = Math.floor( pos[0] + cellWidth / 2 );
	var y = Math.floor( pos[1] + cellHeight / 2 );
	
	preLoadImage( "zoomButtonHover.png" );
	
	doCommand("setwindowposition:"+x+","+y);
});

//サイズ選択の縦横のセルの数
var yokoNum = 6;
var tateNum = 6;

var gridYoko = 2;
var gridTate = 2;

var cellWidth = 24;
var cellHeight = 18;

var shortcutWidth = 24;
var shortcutHeight = 18;

var cellColor = "#8280ff"; //"#ffffff"; //
var cellDefaultColor ="#ffffff"; // "#000000"; //
var cellCancelColor = "#ff8082"

var argvHash = 0;

var isReadyTable = false;

// テーブル内のセルを２次元配列にする
// この配列を碁盤の要領で利用する
var objList = new Array();
// ドラッグ中かどうか
var isDrag = false;
// ドラッグ中の背景色
var dragColor = cellColor;
// ドラッグ開始の座標
var startX;
var startY;

var endX;
var endY;

var preThis = 0;

var flag = 0, sRow, sCell, sFor = 0, eFor = 0;
var Col_def = '', Col_sel = cellColor, Col_S = dragColor, Col_D =dragColor;


var closeTimmer = 0;
var colorToDontActionTimmer = 0;

var isDoResizeAction = 0;
var checkTime = 1000;


function readSettingFromSearch()
{
	var inSearch = parent.location.search;
	var q = new Object();
	if( inSearch )
	{
		var allArray = inSearch.substr(1).split("&");
		for (param in allArray)
		{
			var paramArray = allArray[param].split("=");
			q[ paramArray[0] ] = paramArray[1];
		}
		
		argvHash = q;
	}
	else
	{
		return;
	}
	
	if( q["horizontalGrid"] && checkNumInRange(q["horizontalGrid"], 1, 9999) ){ gridYoko = parseInt( q["horizontalGrid"],10); }
	if( q["verticalGrid"] && checkNumInRange(q["verticalGrid"], 1, 9999) ){ gridTate = parseInt( q["verticalGrid"],10); }
	
	if( q["horizontalCellNum"] && checkNumInRange(q["horizontalCellNum"], 2, 24) ){ tateNum = parseInt( q["horizontalCellNum"],10); }
	if( q["verticalCellNum"] && checkNumInRange(q["verticalCellNum"], 2, 24) ){ yokoNum = parseInt( q["verticalCellNum"],10); }
	
	if( q["cellWidth"] && checkNumInRange(q["cellWidth"], 4, 1000) ){ cellWidth = parseInt( q["cellWidth"],10); }
	if( q["cellHeight"] && checkNumInRange(q["cellHeight"], 4, 1000) ){ cellHeight = parseInt( q["cellHeight"],10); }
	
	if( q["shortcutWidth"] && checkNumInRange(q["shortcutWidth"], 4, 1000) ){ shortcutWidth = parseInt( q["shortcutWidth"],10); }
	if( q["shortcutHeight"] && checkNumInRange(q["shortcutHeight"], 4, 1000) ){ shortcutHeight = parseInt( q["shortcutHeight"],10); }
	
	if( q["userTitle1"] && q["userSize1"] ){ $("#userTitle1").text( decodeURIComponent(q["userTitle1"]) ); }else{ $("#userTitleBox1").text(""); }
	if( q["userTitle2"] && q["userSize2"] ){ $("#userTitle2").text( decodeURIComponent(q["userTitle2"]) ); }else{ $("#userTitleBox2").text(""); }
	if( q["userTitle3"] && q["userSize3"] ){ $("#userTitle3").text( decodeURIComponent(q["userTitle3"]) ); }else{ $("#userTitleBox3").text(""); }
	if( q["userTitle4"] && q["userSize4"] ){ $("#userTitle4").text( decodeURIComponent(q["userTitle4"]) ); }else{ $("#userTitleBox4").text(""); }

}

function doUseSizeCommand( commandNo )
{
	var size = argvHash[ 'userSize'+commandNo ];
	if( size  )//&& size.match(/^size\:/)
	{
		size = decodeURIComponent(size);
		doCommand(size);
	}
	else
	{
		closeWindow();
	}
}

function log(msg)
{
	//$('#log').text(msg);
	
	//var obj1 = new Image();	obj1.src = msg;
}

function preLoadImage( url )
{
	var obj1 = new Image();
	obj1.src = url;
}

function doCommand(cmd)
{
	var obj1 = new Image();
	obj1.src = cmd;
	
	//alert(cmd);
}

	// http://dynamic-tools.net/toolbox/isMouseLeaveOrEnter/
function isMouseLeaveOrEnter(e, handler)
{		
	var reltg = e.relatedTarget ? e.relatedTarget : e.type == 'mouseout' ? e.toElement : e.fromElement;
	while (reltg && reltg != handler) reltg = reltg.parentNode;
	return (reltg != handler);
}
			
function checkNumInRange( n, min, max )
{
	n = parseInt( n,10);
	if( min <= n && n <= max )
	{
		return true;
	}
	
	return false;
}


function mouseoutSelectTableAction()
{

	if( isDrag == false )
	{
		//doCommand('closewindow://closewindow');	
		for(y2 = 0; y2 < objList.length; y2++){
		for(x2 = 0; x2 < objList[y2].length; x2++){
		objList[y2][x2].style.backgroundColor = cellDefaultColor;
		}
		}
	}


}

function mouseoverSelectTableAction()
{
	//clearColorToDontActionTimmer();
}

function mouseoverAction()
{
	clearCloseTimmer();
	clearColorToDontActionTimmer();
}

function closeWindow()
{
	log("f://closeWindow");
	doCommand('closewindow://closewindowfunction');
}

function clearCloseTimmer()
{
	log("f://clearCloseTimmer");
	clearTimeout(closeTimmer);
	closeTimmer = 0;
	
	for(y2 = 0; y2 < objList.length; y2++){
	for(x2 = 0; x2 < objList[y2].length; x2++){
	objList[y2][x2].style.backgroundColor = cellDefaultColor;
	}
	}
}

function clearColorToDontActionTimmer()
{
	clearTimeout(colorToDontActionTimmer);
	colorToDontActionTimmer = 0;
}

function colorToDontAction()
{
	isDoResizeAction = false;

clearTimeout(colorToDontActionTimmer);
colorToDontActionTimmer = 0;

for(y2 = 0; y2 < objList.length; y2++){
for(x2 = 0; x2 < objList[y2].length; x2++){
objList[y2][x2].style.backgroundColor = cellCancelColor;
}
}

}

function mouseoutAction()
{
	log("mouseoutAction://");
if( isDrag == false )
{
	//doCommand('closewindow://closewindow');
	
	clearCloseTimmer();
	closeTimmer = setTimeout("closeWindow()", checkTime);
	
	for(y2 = 0; y2 < objList.length; y2++){
	for(x2 = 0; x2 < objList[y2].length; x2++){
	objList[y2][x2].style.backgroundColor = cellCancelColor;
	}
	}
}
else
{
	clearColorToDontActionTimmer();
	colorToDontActionTimmer = setTimeout("colorToDontAction()", checkTime);
}


}
			
function initWindowSize()
{
	var menuWidth = window.outerWidth - window.innerWidth;
	var menuHeight = window.outerHeight - window.innerHeight;
			
	var dialog = document.getElementById( 'main' );
	
	var newWidth = dialog.clientWidth+menuWidth+0;
	var newHeight = dialog.clientHeight+menuHeight+0;

	//alert(''+newWidth+","+newHeight);
	window.resizeTo(newWidth, newHeight); 
}

function tellSelectedArea()
{
	if(startX>endX)
	{
		var tmp = startX;
		startX = endX;
		endX = tmp;
	}

	if(startY>endY)
	{
		var tmp = startY;
		startY = endY;
		endY = tmp;
	}
	
	//alert("start:"+startX+","+startY+" end:"+endX+","+endY);
	
	doCommand("size:"+yokoNum+","+tateNum+","+startX+","+startY+","+endX+","+endY);
	//location.href= "size:"+yokoNum+","+tateNum+","+startX+","+startY+","+endX+","+endY;
}

function initTable_yokutsukau()
{
	var halfWidth = Math.floor( shortcutWidth / 2 );
	var halfHeight = Math.floor( shortcutHeight / 2 );
	
	addStyleRule( ".halfWidth { width: "+halfWidth+"px  !important; }" );
	addStyleRule( ".halfHeight { height: "+halfHeight+"px  !important; }" );
	addStyleRule( ".fullWidth { width: "+shortcutWidth+"px  !important; }" );
	addStyleRule( ".fullHeight { height: "+shortcutHeight+"px  !important; }" );
}

function initTable()
{
	var html = "";
	
	for( i = 1 ; i<= tateNum ; i++ )
	{
		var tateClass = '';
		
		if( (i % gridTate) == 0 )
		{
			tateClass += " gridBottom";
		}
		
		html += "<tr>";
		 for( n = 1 ; n <= yokoNum ; n++ )
		 {
		 	var tdClass = tateClass;
			 
			 if( (n% gridYoko) == 0 )
			{
				tdClass += " gridRight";
			}
		 
		 	html += "<td class='"+tdClass+"' width="+cellWidth+" height="+cellHeight+">";
			html += " ";
			html += "</td>";
		 }
		 html += "</tr>";
	}
	
	$('#selectBody').html(html);
}



function initSelect(){
// http://oshiete.goo.ne.jp/qa/3871770.html
var x, y;
var objTable = document.getElementById("selectTable");
var objTrList = objTable.getElementsByTagName("tr");


//document.getElementById("main").onmouseout="if (isMouseLeaveOrEnter(event, this)){mouseoutAction()}";
//document.getElementById("main").onmouseover="if (isMouseLeaveOrEnter(event, this)){ mouseoverAction();}";

window.onmouseup =  function(){
	if( ! isReadyTable ){ return; }
	
	if( isDoResizeAction && isDrag )
	{
		tellSelectedArea();
	}
	else if( isDrag )
	{
		for(y2 = 0; y2 < objList.length; y2++){
			for(x2 = 0; x2 < objList[y2].length; x2++){
				objList[y2][x2].style.backgroundColor = cellDefaultColor;
			}
		}
		isDrag = 0;
		
		//log("mouseup");
		doCommand('closewindow://window.onmouseup');	//終了する。
	}
};

// Y軸をループ
for(y = 0; y < objTrList.length; y++){
// objListを初期化していく
objList[y] = objTrList[y].getElementsByTagName("td");

// X軸をループ
for(x = 0; x < objList[y].length; x++){
// セルにXとYの座標を保持
objList[y][x].x = x;
objList[y][x].y = y;
// セルに背景色を保持
objList[y][x].color = cellDefaultColor;



objList[y][x].onmouseup = function(){
if( ! isReadyTable ){ return; }

if(isDrag){
var x2, y2;

endX = this.x;
endY = this.y;
tellSelectedArea();

for(y2 = 0; y2 < objList.length; y2++){
for(x2 = 0; x2 < objList[y2].length; x2++){
if(isSelect(objList[y2][x2], this.x, this.y)){
objList[y2][x2].style.backgroundColor = cellColor;
objList[y2][x2].color = cellColor;
}
}
}
isDrag = false;
}
}


// クリックしたときの処理
objList[y][x].onmousedown = function(){
if( ! isReadyTable ){ return; }

isDoResizeAction = true;
clearCloseTimmer();
clearColorToDontActionTimmer();

if(isDrag){
var x2, y2;

endX = this.x;
endY = this.y;
tellSelectedArea();

for(y2 = 0; y2 < objList.length; y2++){
for(x2 = 0; x2 < objList[y2].length; x2++){
if(isSelect(objList[y2][x2], this.x, this.y)){
objList[y2][x2].style.backgroundColor = cellColor;
objList[y2][x2].color = cellColor;
}
}
}
isDrag = false;
}else{
// ドラッグ開始
startX = this.x;
startY = this.y;
isDrag = true;
}
}

// ドラッグ中の処理
objList[y][x].onmouseover = function(){
if( ! isReadyTable ){ return; }

clearCloseTimmer();
clearColorToDontActionTimmer();
isDoResizeAction = true;

// ドラッグ中でない場合は終了
if(!isDrag){ 
//hoverでハイライト　動かないアプリが多いので停止 //理由が分かった
for(y2 = 0; y2 < objList.length; y2++){
for(x2 = 0; x2 < objList[y2].length; x2++){
objList[y2][x2].style.backgroundColor = cellDefaultColor;
}
}
this.style.backgroundColor = dragColor;


return; }

// ドラッグ中は背景色を変更する
var x2, y2;

endX = this.x;
endY = this.y;

for(y2 = 0; y2 < objList.length; y2++){
for(x2 = 0; x2 < objList[y2].length; x2++){
if(isSelect(objList[y2][x2], this.x, this.y)){
objList[y2][x2].style.backgroundColor = dragColor;
}else{
objList[y2][x2].style.backgroundColor = objList[y2][x2].color;
}
}
}
}
}
}
}

// 指定セルが、ドラッグの範囲かどうかを判定する
function isSelect(obj, x, y){
var flgX, flgY;

// 左右の判定
if(x >= startX){
flgX = (startX <= obj.x && obj.x <= x);
}else{
flgX = (x <= obj.x && obj.x <= startX);
}

// 上下の判定
if(y >= startY){
flgY = (startY <= obj.y && obj.y <= y);
}else{
flgY = (y <= obj.y && obj.y <= startY);
}

return (flgX && flgY);
}


function changeColor(obj){
var color = obj.options[obj.selectedIndex].style.backgroundColor;
obj.style.backgroundColor = color;
cellColor = color;
}



function htmlspecialchars(ch) { 
ch = ch.replace(/&/g,"&amp;") ;
ch = ch.replace(/"/g,"&quot;") ;	//"
ch = ch.replace(/'/g,"&#039;") ;	//'
ch = ch.replace(/</g,"&lt;") ;
ch = ch.replace(/>/g,"&gt;") ;
return ch ;
}


function htmlspecialcharsDecode(ch) { 
ch = ch.replace(/&quot;/g,'"') ;	//"
ch = ch.replace(/&#039;/g,"'") ;	//'
ch = ch.replace(/&lt;/g,"<") ;
ch = ch.replace(/&gt;/g,">") ;
ch = ch.replace(/&nbsp;/g," ") ;
ch = ch.replace(/&amp;/g,"&") ;
return ch ;
}

function addStyleRule( inStyle )
{
	//insertRuleだとFirefoxで元スレ表示のときにスタイルが変わらなかった
	var element = document.createElement('style');
	element.type= 'text/css';
	
	var textNode = document.createTextNode( inStyle );
	//element.innerHTML = inStyle;
	element.appendChild( textNode );
	
	document.getElementsByTagName('head')[0].appendChild(element);
}

//objの縦横の位置を取得
//From http://www.quirksmode.org/js/findpos.html
function findPos(obj) {
	var curleft = curtop = 0;
	if (obj.offsetParent) {
		curleft = obj.offsetLeft
		curtop = obj.offsetTop
		while (obj = obj.offsetParent) {
			curleft += obj.offsetLeft
			curtop += obj.offsetTop
		}
	}
	return [curleft,curtop];
}

